#include <stdio.h>
#include <math.h>

#define G 9.8

typedef float FUZZY;

model (manual, mass_car, mass_rod, length_rod, xpos, dxpos, phi, dphi, control)

FUZZY *manual, *mass_car, *mass_rod, *length_rod;
FUZZY *xpos, *dxpos, *phi, *dphi, *control;
{
  float inc_phi, inc_xpos;
  float phi_old, xpos_old;
  float phi_new, xpos_new;
  float  a,b,c,d, aa, ii;
  float accion;

  ii = *mass_rod * *length_rod * *length_rod/3;
  aa = ii * (*mass_rod+*mass_car) + *mass_rod * *mass_car * *length_rod * *length_rod;
  a  = G * (*mass_rod+*mass_car) * *mass_rod * *length_rod/aa;
  b  = *mass_rod * *length_rod / aa;
  c  = -G * *mass_rod * *mass_rod * *length_rod * *length_rod / aa;
  d  = -(ii + *mass_rod * *length_rod * *length_rod) / aa;

  accion = *manual * *control;
  phi_old = *phi/57.3; /* convert degrees to radians */
  inc_phi = *dphi/57.3;

  phi_new = phi_old + .04 * (inc_phi + .04*(a*phi_old +b*accion));
  if ( phi_new > (90/57.3)) /*Avoid inclination larger or smaller than 90 deg.*/
    phi_new = (90/57.3);
  if ( phi_new < (-90/57.3))
    phi_new = (-90/57.3);

  inc_phi = phi_new - phi_old;

  xpos_old = *xpos/100.;
  inc_xpos = *dxpos/100.;
  xpos_new = xpos_old + .04 * (inc_xpos + .04 * (c*phi_old +d*accion)); 
  inc_xpos = xpos_new - xpos_old;

  *xpos = xpos_new*100;
  *dxpos = inc_xpos*100; 

  *phi = phi_new *57.3; /* Reconvert radians to degrees */
  *dphi = inc_phi *57.3;
}

